import fcm
import numpy as np
import matplotlib.pyplot as plt
from fcm.graphics import bilinear_interpolate
import glob


cols = [0,1,2,3,6]
hs = ['FSC', 'SSC', 'CD45', 'CD3', 'Tet']

dims = [(0,1), (3,2), (4,2)]

n = len(dims)

for i, c in enumerate(hs):
    print i, c

g01 = np.load('gate_0_1.npy')
g32 = np.load('gate_3_2.npy')
g42 = np.load('gate_4_2.npy')
gates = [g01, g32, g42]

for file in glob.glob('*membership.txt'):
    print file
    xs = np.loadtxt(file, skiprows=1)
    print xs.shape
    center_file = file.replace('membership','locations')
    centers = np.loadtxt('%s' % center_file, skiprows=1)
    fig = plt.figure(figsize=(12,4))
    for k, dim in enumerate(dims):
        ax = fig.add_subplot(1,n,k+1)
        x = xs[:, dim[0]]
        y = xs[:, dim[1]]
        #z = bilinear_interpolate(x, y, 100)
	c = xs[:, -1]
        #iz = np.argsort(z)
        ax.scatter(x, y, c=c, s=1, edgecolors='none')
        ax.set_xlabel(hs[dim[0]], fontsize=14)
        ax.set_ylabel(hs[dim[1]], fontsize=14)
        #ax.axis([0,1024,0,1024])
        ax.set_xticks([])
        ax.set_yticks([])
        #ax.fill(gates[k][0], gates[k][1], facecolor='none', edgecolor='red')
   	for i in range(centers.shape[0]):
		ax.text(centers[i,dim[0]],centers[i,dim[1]], str(i), bbox=dict(facecolor='yellow', alpha=0.5))
    fig.tight_layout()
    fig.savefig('gated_%s.png' % file)
