#/usr/bin/bash

# Runs on Mac OS X and Unix systems

# generate figure 3
# set numgpu to the number of CUDA devices in your system
numgpu=1
n=$((numgpu-1))
os=`uname`
if [ "$os" = "Darwin" ]
then
    cmd=`jot - 0 $n`
else
    cmd=`seq 0 $n`
fi

# assumes 10 or fewer GPU devices
for i in $cmd
do
    device=$device$i
done

nclusts=$1
iter=$2
burnin=$3

for ((seed=$4; seed<=$5; seed++))
do
    python fit_hdp_nclust.py $device $seed $nclusts $iter $burnin
    python plot_hdp_tet.py $device $seed $nclusts $iter $burnin
    python fit_dp_nclust.py $device $seed $nclusts $iter $burnin
    python plot_dp_tet.py $device $seed $nclusts $iter $burnin
done

