import matplotlib
matplotlib.use('Agg')
import numpy as np
import pylab
import os
import utils_cc as utils
from matplotlib.nxutils import points_inside_poly
import subprocess
import sys

__author__ = 'cliburn'

if __name__ == '__main__':

    result_dir = '../results'

    name = 'plos_xs'
    nclusts = int(sys.argv[1])
    niter = int(sys.argv[2])
    burnin = int(sys.argv[3])
    start = int(sys.argv[4])
    stop = int(sys.argv[5])
    device = 0

    xss = np.load('../results/plos_xs.npy')
    dims = [(0,1), (3,2), (4,2)]

    for seed in range(start, stop):

        if os.path.exists(os.path.join(result_dir, 'freqs_%s.npy' % seed)):
            continue

        freqs = []
        for e in [0.3, 1.0, 3.0]:
            for f in [0.3, 1.0, 3.0]:
                for g in [0.3, 1.0, 3.0]:
                    for h in [0.3, 1.0, 3.0]:

                        identifier = '%s_%s_k%d_i%d_b%d_s%d_e%.2f_f%.2f_g%.2f_h%.2f_rep0' % ('plos', name, nclusts, niter, burnin, seed, e, f, g, h)
                        try:
                            cs = utils.unpickle(os.path.join(result_dir,
                                                             '%s_cs.pic.gz' % identifier))
                        except:
                            cmd = ['python', 'fit.py'] + map(str, ['../results/plos_xs.npy', niter, burnin, nclusts, seed, device, e, f, g, h])

                            print ' '.join(cmd)

                            subprocess.call(cmd)
                            cs = utils.unpickle(os.path.join(result_dir,
                                                              '%s_cs.pic.gz' % identifier))

                        for j, xs in enumerate(xss):
                            print j

                            c = cs[j]
                            centroids = c.modes()
                            zs = c.classify(xs)

                            targets = np.ones(len(centroids), 'bool')
                            for k, dim in enumerate(dims):
                                gate = np.load(os.path.join('../data', 'gate_%d_%d.npy' % dim))
                                targets &= points_inside_poly(centroids[:, dim], gate.T)
                            targets = np.arange(len(targets))[targets]

                            idx = np.zeros(len(zs), 'bool')
                            for target in targets:
                                idx |= zs==target

                            freq = 100.0*np.sum(idx)/len(idx)

                            freqs.append([identifier, seed, e, f, g, h, freq])
        np.save(os.path.join(result_dir, 'freqs_%s.npy' % seed), freqs)

