__author__ = 'cliburn'

import matplotlib
matplotlib.use('Agg')
import utils_cc as utils
import numpy as np
import os
import pylab
import sys

data_dir = '../results'

if __name__ == '__main__':
    target = os.path.join(data_dir, 'plos_xs.npy')
    xss = np.load(target)

    k = int(sys.argv[1])
    i = int(sys.argv[2])
    b = int(sys.argv[3])
    s = int(sys.argv[4])

    rss = utils.unpickle(os.path.join(data_dir, 'plos_plos_xs_k%d_i%d_b%d_s%d_e1.00_f1.00_g1.00_h1.00_rep0_rss.pic.gz' % (k, i, b, s)))

    print "load completed"

    niter = i

    lls = []
    mms = []
    for i, (rs, xs) in enumerate(zip(rss, xss)):
        print i
        ll = [rs.get_iteration(i).log_likelihood(xs[:,:]) for i in range(0, niter)]
        mm = [rs.get_iteration(i).mus for i in range(0, niter)]
        lls.append(ll)
        mms.append(mm)

    np.save(os.path.join(data_dir, 'plos_lls.npy'), lls)
    np.save(os.path.join(data_dir, 'plos_mms.npy'), mms)
