__author__ = 'cliburn'

import matplotlib
matplotlib.use('Agg')
import utils_cc as utils
import numpy as np
import os
import pylab
import sys

data_dir = '../results'

nclusts = int(sys.argv[1])
niter = int(sys.argv[2])
burnin = int(sys.argv[3])
seed = int(sys.argv[4])

rs = utils.unpickle(os.path.join(data_dir, 'plos_plos_xs_k%d_i%d_b%d_s%d_e1.00_f1.00_g1.00_h1.00_rep0_rs.pic.gz' % (nclusts, niter, burnin, seed)))

labels = ['%.4f%%' % f for f in [0] + [0.21/(2**i) for i in range(5)][::-1]]
ymin = -6
ymax = 0

for j, k in enumerate([0,3,1,4,2,5]):
    pylab.subplot(3,2,j+1)
    pylab.plot(np.log10(sorted(rs[k].pis, reverse=True)), '.')
    pylab.xlim(0,nclusts)
    if j==2:
        pylab.ylabel(r'$\log_{10}(\pi_{i})$', fontsize=18)
    pylab.text(95, ymin+0.85*(ymax-ymin), labels[j], bbox=dict(facecolor='yellow', alpha=0.5))
    if j==4 or j==5:
        pylab.xlabel('Mixture component')

pylab.tight_layout()
pylab.savefig('../figs/pis.pdf')
