__author__ = 'cliburn'

import numpy as np
import pylab
import sys

freqs201 = np.load('../results/freqs_201.npy')
freqs202 = np.load('../results/freqs_202.npy')
freqs203 = np.load('../results/freqs_203.npy')

vals201 = freqs201[:,1:].astype('float')
vals202 = freqs202[:,1:].astype('float')
vals203 = freqs203[:,1:].astype('float')

vals = np.vstack([vals201, vals202, vals203])
print vals.shape

e = 0.3
f = 0.3
g = 0.3
h = 0.3
print vals[:2, :]

pylab.figure(figsize=(12,12))
k = 1
for e in [0.3, 1.0, 3.0]:
    for f in [0.3, 1.0, 3.0]:
        for g in [0.3, 1.0, 3.0]:
            for h in [0.3, 1.0, 3.0]:
                pylab.subplot(9,9,k)
                xs = vals[(vals[:,1]==e) & (vals[:,2]==e) & (vals[:,3]==g) & (vals[:,4]==h), -1]
                xs = xs.reshape((3, 6))
                k += 1
                pylab.boxplot(xs)
                pylab.xticks([])
                pylab.yticks([])

                if e==1 and f==1 and g==1 and h==1:
                    c = 'red'
                else:
                    c = 'black'

                pylab.text(3.5, 0.22, '$e=%.1f$' % e, color=c, ha='right')
                pylab.text(3.5, 0.18, '$f=%.1f$' % f, color=c, ha='right')
                pylab.text(3.5, 0.14, '$e_0=%.1f$' % g, color=c, ha='right')
                pylab.text(3.5, 0.10, '$f_0=%.1f$' % h, color=c, ha='right')

pylab.tight_layout()
pylab.savefig('../figs/sensitivity.pdf')


