__author__ = 'cliburn'

import matplotlib
matplotlib.use('Agg')
import utils_cc as utils
import numpy as np
import os
import pylab

base_dir = '.'
data_dir = '../results'

if __name__ == '__main__':
    lls = np.load(os.path.join(data_dir, 'plos_lls.npy'))
    mms = np.load(os.path.join(data_dir, 'plos_mms.npy'))

    labels = ['%.4f%%' % f for f in [0] + [0.21/(2**i) for i in range(5)][::-1]]

    ymin = np.min(lls[np.isfinite(lls)])
    ymax = np.max(lls[np.isfinite(lls)])

    lls = np.array(lls)[[0,3,1,4,2,5]]
    labels = np.array(labels)[[0,3,1,4,2,5]]

    for k, ll in enumerate(lls):
        pylab.subplot(3,2,k+1)
        pylab.plot(20000+np.arange(len(ll))[::10], ll[::10])
        pylab.ylim(ymin, ymax)
        if k==4 or k==5:
            pylab.xlabel('MCMC iterations')
        if k==2:
            pylab.ylabel('Log likelihood')
        pylab.text(21400, ymin+0.85*(ymax-ymin), labels[k], bbox=dict(facecolor='yellow', alpha=0.5))
    pylab.tight_layout()
    pylab.savefig('../figs/log_likelihood_trace.pdf')

