import numpy as np

def pickle(fname, obj):
    import cPickle, gzip
    cPickle.dump(obj=obj, file=gzip.open(fname, "wb", compresslevel=3), protocol=2)

def unpickle(fname):
    import cPickle, gzip
    return cPickle.load(gzip.open(fname, "rb"))

def batch_classify(x, classify, size=100000):
    """Break classification into small batches to avoid out of memory errors"""
    n, p = x.shape
    start = 0
    z = []
    while (start < n):
        z.append(classify(x[start:(start+size),:]))
        start += size
    return np.concatenate(z)

def modal_pi(x):
    rslt = []
    for j in x.cmap.keys():
        rslt.append(np.sum(x.pis()[x.cmap[j]]))
    return np.array(rslt)

